{ Philcopy
  Copier un rpertoire ou bien des fichiers
  sur plusieurs ressources rseau simultanment.
  test sour win98SE.
  compatibilit XP  vrifier, certaines fonctions rseau
  pouvant diffrer.
  XP et 98 sur le mme rseau provoquent souvent des problmes
  d'identification des ressources... }

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, MFileExplorer, FileListView, FolderTree, StdCtrls, FileCtrl,
  CheckLst, Buttons;

type
  TDepart = class(TForm)
    GroupBox1: TGroupBox;
    DL: TFolderTree;
    FL: TFileListBox;
    GroupBox2: TGroupBox;
    ListeBack: TListBox;
    bparcourir: TSpeedButton;
    ListeR: TCheckListBox;
    SpeedButton1: TSpeedButton;
    LabelA: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    procedure DLChange(Sender: TObject; Node: TTreeNode);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListeRDblClick(Sender: TObject);
    procedure DLClick(Sender: TObject);
    procedure FLClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    procedure traiteContainer(PBufferI:PNetResource);
    procedure Copietout;
  public
    { Dclarations publiques }
  end;

var
  Depart: TDepart;
  repd:string;
  copie:integer;
  nomrep:string;

implementation

{$R *.DFM}

{ procedure de copie d'un rpertoire.
un bon exemple de rcursivit: la procdure s'appelle elle-mme.
Pour chaque appel, de nouvelles variables locales sont cres, ainsi
il n'y a pas confusion. En pascal, une variable locale n'existe
qu' l'intrieur de la procdure ou fonction. Elle est dtruite 
la fin de l'excution. Il faut prvoir un test de sortie car si le
nombre d'appels rcursifs est trop grand, les limites du systme sont
vites atteintes. Cela est du au fait que lors de l'appel d'une
proddure ou fonction, l'adresse de retour est stocke dans la pile.
Si le nombre d'appels imbriqus est trop grand, cela cause un
"dbordement de pile" }

{ l'exemple habituellement utilis pour la rcursivit est
  le calcul de factorielles }

procedure CopyRep(dep,arr:string);
var k:integer;
    SRT : TSearchRec;
begin
// mise en forme des noms de rpertoires
   if Copy(dep,length(dep),1)<>'\' then dep:=dep+'\';
   if Copy(Arr,length(arr),1)<>'\' then Arr:=Arr+'\';
// cration du rpertoire cible
   try Forcedirectories(Arr) except end;
// copie des fichiers
   // recherche de la premire occurence
   k:=FindFirst(dep+'*.*',FaAnyfile,SRT);
   // fichier trouv si k=0, sinon c'est fini.
   while k=0 do begin
      // est-ce un rpertoire ?
      if (SRT.attr AND faDirectory)<>0 then begin { rpertoire }
         // n'est-ce pas un rpertoire parent ?
         if SRT.name[1]<>'.' then begin
            // cration du rpertoire cible
            try Forcedirectories(Arr+SRT.name) except end;
            // appel rcursif
            CopyRep(Dep+SRT.name,Arr+SRT.name);
         end;
      end else begin
         // c'est un fichier  copier
         CopyFile(Pchar(Dep+SRT.name),Pchar(Arr+SRT.name),FALSE);
         // retirer l'attribut lecture seule ( pour provenance cdrom)
         Filesetattr(Arr+SRT.name,SRT.attr AND 254);
      end;
      // recherce de l'occurence suivante
      k:=FindNext(SRT);
   end;
   // tous les fichiers ont t examins, on sort.
end;

{ procdure de copie multiple }
procedure Tdepart.copietout;
var k,q:integer;
    R:string;
    trouve,cible:boolean;
begin
// pour l'instant, pas de cible identifie
   cible:=false;
// on parcourt la liste des cibles rseau
   for k:=0 to ListeR.items.count-1 do begin
      // si ressource coche
      if ListeR.checked[k] then begin
         // une cible a t trouve
         cible:=true;
         // rpertoire, ou fichier ?
         // tout dpend de la valeur de la variable copie
         Case copie of
            1: begin
                 // le rpertoire existe t-il ?
                 // ce pourrait tre un lecteur amovible vide.
                 {$I-} chdir(DL.directory); {$I+}
                 if ioresult=0 then begin // il existe bien
                    // ajout ventuel du slash de fin
                    R:=IncludeTrailingBackslash(ListeR.items[k]);
                    // Copie du rpertoire
                    // nomrep est le rpertoire slectionn dans
                    // la liste des rpertoires
                    Copyrep(DL.directory,R+nomrep);
                 end else begin
                    // le rpertoire n'existait pas.
                    Showmessage('Rien  copier !');
                    exit;
                 end;
               end;
            2: begin
                 // aucun fichier copi pour l'instant
                 trouve:=false;
                 // fichier(s) slectionn(s) ?
                 if FL.items.count>0 then begin
                    // rpertoire cible et ajout du slash
                    R:=IncludeTrailingBackslash(ListeR.items[k]);
                    // on parcourt la liste des fichiers
                    for q:=0 to FL.items.count-1 do begin
                       if FL.selected[q] then begin // slectionn ?
                          // on copie le fichier
                          CopyFile(Pchar(expandfilename(FL.items[q])),
                             Pchar(R+FL.items[q]),false);
                          // au moins un fichier a t copi
                          trouve:=true;
                       end;
                    end;
                    // y a t-il eu des fichiers copi ?
                    if not trouve then begin
                       // non.
                       Showmessage('Rien  copier !');
                       exit;
                    end;
                 end else begin
                    // aucun fichier slectionn
                    Showmessage('Rien  copier !');
                    exit;
                 end;
               end;
         end;
      end;
   end;
   // y a t-il eu une cible utilise ?
   if not cible then begin
      // non
      Showmessage('Pas de dossier cible !');
      exit;
   end;
   // message de fin.
   // en cas d'erreur, la sortie s'est effectue avant,
   // avec l'instruction exit;
   Showmessage('Copie termine.');
end;


{ procdure de recueil des ressources rseau
utilise des fonctions network de l'API windaub }

procedure TDepart.TraiteContainer(PBufferI: PNetResource);
type
  tBufferResultat = array[0..0] of TNetResource;
  tpBufferResultat = ^tBufferResultat;
var
  HandleEnum:THandle;
  NbRessources:DWord;
  TailleBuffer:DWord;
  i:integer;
  pBufferResultat: tpBufferResultat;
  NumErreur:integer;

begin
   if WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, PBufferI, HandleEnum) <> NO_ERROR then
     ShowMessage('Erreur' + IntToStr(GetLastError))
   else
   begin
     // allouer un buffer avec une taille arbitraire (pas 0 sinon pBufferResultat serait : nil
     TailleBuffer :=16384;// 16Ko
     pBufferResultat := AllocMem(TailleBuffer);
     NumErreur:=NO_ERROR;

     // boucler tant qu'il y a des ressources  numrer et qu'il n'y a pas d'erreur
     while NumErreur<>ERROR_NO_MORE_ITEMS do //Tant qu'il y a des ressources  trouver
     begin
       NbRessources := $ffffffff; // on ne limite pas le nombre de ressources demandes
       NumErreur:=WNetEnumResource(HandleEnum, NbRessources, pBufferResultat, TailleBuffer);
      //NbRessource contient maintenant le nomnbre de ressource de ce container
      //(container = noeud si on considre l'arborescence du rseau)
      //(Ressource = branche si on considre l'arborescence du rseau)

       case  NumErreur of
         ERROR_MORE_DATA:
           // le buffer tait trop petit pour rcuprer une resource,
           // rallouer de la mmoire en tenant compte de la nouvelle valeur de TailleBuffer
           // renvoye par WNetEnumResource
           ReallocMem(pBufferResultat, TailleBuffer);
           // cela dit, avec TailleBuffer=16Ko, peu de chance d'avoir ce problme

         NO_ERROR:
           begin
             // pas d'erreur, on peut donc exploiter les ressources renvoyes par le Buffer
             // le nombre de ressources renvoyes est limit par la taille du Buffer (TailleBuffer)
             // s'il y a d'autres ressources, elles seront renvoyes au prochain tour du While
             for i:=0 to NbRessources-1 do
             begin
               // uniquement les ressources disque
               if pBufferResultat^[i].dwtype=1 then begin
                  // ajout  la liste des ressources
                  ListeR.items.Add(string(pBufferResultat^[i].lpRemoteName));
                     //+inttostr(pBufferResultat^[i].dwtype));
                  // Ajout  la liste tmoin
                  ListeBack.items.Add(string(pBufferResultat^[i].lpRemoteName));
               end;
               if pBufferResultat^[i].dwUsage and RESOURCEUSAGE_CONTAINER=RESOURCEUSAGE_CONTAINER then
                   traiteContainer(@pBufferResultat^[i]);// une petite rcursivit pour aller plus profond dans l'arbre....
             end;
           end
         else
           if NumErreur<> ERROR_NO_MORE_ITEMS then
           begin
             // une vraie erreur est survenue
             ShowMessage('Erreur' + IntToStr(GetLastError));
             break; // pour sortir du While
           end;
       end; // fin du case
     end;   // fin du while
     WNetCloseEnum(HandleEnum);// libration des ressources
     FreeMem(pBufferResultat);// libration de la mmoire
   end;
end;

// vnement OnChange de la bote des rpertoires
procedure TDepart.DLChange(Sender: TObject; Node: TTreeNode);
begin
   // le rpertoire slectionn est-il accessible ?
   {$I-} chdir(DL.directory); {$I+}
   if ioresult=0 then begin
      // oui, on transfre ce rpertoire  la liste fichiers
      Fl.directory:=DL.Directory;
      //On stocke le nom du rpertoire pour utilisation dans copietout
      nomrep:=Node.text;
   end else begin
      // rpertoire inaccessible
      nomrep:='';
   end;
end;

// Evnement OnActivate de la fentre principale
// lance la recherche des ressources rseau.
procedure TDepart.FormActivate(Sender: TObject);
begin
   TraiteContainer(nil);
end;

//Evnement OnCreate de la ^fiche principale
procedure TDepart.FormCreate(Sender: TObject);
begin
   // stockage du rpertoire de dpart
   getdir(0,repd);
   // copie initialis  0
   // 1 = rpertoire, 2 = fichier(s)
   copie:=0;
end;

// double-clic sur la liste des ressources
procedure TDepart.ListeRDblClick(Sender: TObject);
var R:string;
begin
   // liste vide => on sort
   if ListeR.itemindex=-1 then exit;
   // stocakge du dossier dans R
   R:=ListeR.items[Lister.itemindex];
   // on parcourt la ressource tmoin
   if Selectdirectory('Parcourir',ListeBack.items[ListeR.itemindex],R) then begin
      // si OK cliqu, le dossier est modifi dans la liste
      ListeR.items[Lister.itemindex]:=R;
   end;
end;

// clic sur la liste des rpertoires
procedure TDepart.DLClick(Sender: TObject);
begin
   copie:=1;
   LabelA.caption:='Le rpertoire slectionn sera copi.';
end;

// clic sur la liste des fichiers
procedure TDepart.FLClick(Sender: TObject);
begin
   copie:=2;
   LabelA.caption:='Les fichiers slectionns seront copis.';
end;

// clic sur le bouton COPIER
procedure TDepart.SpeedButton1Click(Sender: TObject);
begin
   if copie=0 then begin
      Showmessage('Rien  copier !');
      exit;
   end;
   copietout;
end;

// Clic Info
procedure TDepart.SpeedButton2Click(Sender: TObject);
begin
   Showmessage('ZeKi pour Phil B.');
end;

// Clic sur le bouton mise  jour des ressources
procedure TDepart.SpeedButton3Click(Sender: TObject);
begin
   ListeR.clear;
   ListeBack.clear;
   TraiteContainer(nil);
end;

end.
